﻿Public Class TriGenerator

    Dim lstFreq As New List(Of FrequencyInfo)

    Sub New()

    End Sub

    Sub addFrequency(Frequency As Double, Amplitude As Double, Optional Phase As Double = 0)
        If Frequency < 20 OrElse Frequency > 40000 Then
            Throw New NotImplementedException(Frequency.ToString())
        End If
        lstFreq.Add(New FrequencyInfo() With {.Frequency = Frequency, .Phase = Phase, .Amplitude = Amplitude})
    End Sub

    Function Invoke(t As Double) As Double
        Dim data As Double = 0.0

        For Each f In lstFreq
            data += f.Amplitude * (4 * Math.Abs(2 * Math.PI * f.Frequency * (t + f.Phase) - Math.Round(2 * Math.PI * f.Frequency * (t + f.Phase))) - 1)
        Next
        Return data
    End Function

    Function getFunc() As Func(Of Double, Double)
        Return AddressOf Invoke
        'Return Function(t As Single) As Ty
        '           Return Invoke(t)
        '       End Function
    End Function

End Class
